diff -r 2e3398c71cd2 -r f0e0ff89e1c9 main/channel.c
--- a/main/channel.c	Mon Dec 09 21:26:31 2013 +0000
+++ b/main/channel.c	Mon Dec 09 21:27:18 2013 +0000
@@ -3120,14 +3120,14 @@
 	void *generatordata = NULL;
 
 	ast_channel_lock(chan);
+	if (gen->alloc && !(generatordata = gen->alloc(chan, params))) {
+		res = -1;
+	}
 	if (ast_channel_generatordata(chan)) {
 		if (ast_channel_generator(chan) && ast_channel_generator(chan)->release) {
 			ast_channel_generator(chan)->release(chan, ast_channel_generatordata(chan));
 		}
 	}
-	if (gen->alloc && !(generatordata = gen->alloc(chan, params))) {
-		res = -1;
-	}
 	ast_channel_generatordata_set(chan, generatordata);
 	if (!res) {
 		ast_settimeout(chan, 50, generator_force, chan);
diff -r 2e3398c71cd2 -r f0e0ff89e1c9 res/res_musiconhold.c
--- a/res/res_musiconhold.c	Mon Dec 09 21:26:31 2013 +0000
+++ b/res/res_musiconhold.c	Mon Dec 09 21:27:18 2013 +0000
@@ -1529,7 +1529,7 @@
 						if (state->class->realtime && !ast_test_flag(global_flags, MOH_CACHERTCLASSES) && !strcasecmp(mohclass->name, state->class->name)) {
 							/* we found RT class with the same name, seems like we should continue playing existing one */
 							mohclass = mohclass_unref(mohclass, "unreffing potential mohclass (channel already has one)");
-							mohclass = state->class;
+							mohclass = mohclass_ref(state->class, "reffing state->class as local mohclass in start");
 						}
 					} else {
 						if (ast_pthread_create_background(&mohclass->thread, NULL, monmp3thread, mohclass)) {
